// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/BasicLaneInformation.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__BASIC_LANE_INFORMATION__TRAITS_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__BASIC_LANE_INFORMATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_denm_ts_msgs/msg/detail/basic_lane_information__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'lane_number'
// Member 'connecting_lane'
#include "etsi_its_denm_ts_msgs/msg/detail/lane_position__traits.hpp"
// Member 'direction'
#include "etsi_its_denm_ts_msgs/msg/detail/direction__traits.hpp"
// Member 'lane_width'
#include "etsi_its_denm_ts_msgs/msg/detail/lane_width__traits.hpp"
// Member 'connecting_road_section'
#include "etsi_its_denm_ts_msgs/msg/detail/road_section_id__traits.hpp"

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const BasicLaneInformation & msg,
  std::ostream & out)
{
  out << "{";
  // member: lane_number
  {
    out << "lane_number: ";
    to_flow_style_yaml(msg.lane_number, out);
    out << ", ";
  }

  // member: direction
  {
    out << "direction: ";
    to_flow_style_yaml(msg.direction, out);
    out << ", ";
  }

  // member: lane_width
  {
    out << "lane_width: ";
    to_flow_style_yaml(msg.lane_width, out);
    out << ", ";
  }

  // member: lane_width_is_present
  {
    out << "lane_width_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.lane_width_is_present, out);
    out << ", ";
  }

  // member: connecting_lane
  {
    out << "connecting_lane: ";
    to_flow_style_yaml(msg.connecting_lane, out);
    out << ", ";
  }

  // member: connecting_lane_is_present
  {
    out << "connecting_lane_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.connecting_lane_is_present, out);
    out << ", ";
  }

  // member: connecting_road_section
  {
    out << "connecting_road_section: ";
    to_flow_style_yaml(msg.connecting_road_section, out);
    out << ", ";
  }

  // member: connecting_road_section_is_present
  {
    out << "connecting_road_section_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.connecting_road_section_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const BasicLaneInformation & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: lane_number
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lane_number:\n";
    to_block_style_yaml(msg.lane_number, out, indentation + 2);
  }

  // member: direction
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "direction:\n";
    to_block_style_yaml(msg.direction, out, indentation + 2);
  }

  // member: lane_width
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lane_width:\n";
    to_block_style_yaml(msg.lane_width, out, indentation + 2);
  }

  // member: lane_width_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lane_width_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.lane_width_is_present, out);
    out << "\n";
  }

  // member: connecting_lane
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "connecting_lane:\n";
    to_block_style_yaml(msg.connecting_lane, out, indentation + 2);
  }

  // member: connecting_lane_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "connecting_lane_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.connecting_lane_is_present, out);
    out << "\n";
  }

  // member: connecting_road_section
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "connecting_road_section:\n";
    to_block_style_yaml(msg.connecting_road_section, out, indentation + 2);
  }

  // member: connecting_road_section_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "connecting_road_section_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.connecting_road_section_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const BasicLaneInformation & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_denm_ts_msgs::msg::BasicLaneInformation & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_denm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_denm_ts_msgs::msg::BasicLaneInformation & msg)
{
  return etsi_its_denm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_denm_ts_msgs::msg::BasicLaneInformation>()
{
  return "etsi_its_denm_ts_msgs::msg::BasicLaneInformation";
}

template<>
inline const char * name<etsi_its_denm_ts_msgs::msg::BasicLaneInformation>()
{
  return "etsi_its_denm_ts_msgs/msg/BasicLaneInformation";
}

template<>
struct has_fixed_size<etsi_its_denm_ts_msgs::msg::BasicLaneInformation>
  : std::integral_constant<bool, has_fixed_size<etsi_its_denm_ts_msgs::msg::Direction>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::LanePosition>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::LaneWidth>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::RoadSectionId>::value> {};

template<>
struct has_bounded_size<etsi_its_denm_ts_msgs::msg::BasicLaneInformation>
  : std::integral_constant<bool, has_bounded_size<etsi_its_denm_ts_msgs::msg::Direction>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::LanePosition>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::LaneWidth>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::RoadSectionId>::value> {};

template<>
struct is_message<etsi_its_denm_ts_msgs::msg::BasicLaneInformation>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__BASIC_LANE_INFORMATION__TRAITS_HPP_
