// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_denm_ts_msgs:msg/IvimReference.idl
// generated code does not contain a copyright notice
#include "etsi_its_denm_ts_msgs/msg/detail/ivim_reference__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `service_provider_id`
#include "etsi_its_denm_ts_msgs/msg/detail/provider__functions.h"
// Member `ivi_identification_number`
#include "etsi_its_denm_ts_msgs/msg/detail/ivi_identification_number__functions.h"

bool
etsi_its_denm_ts_msgs__msg__IvimReference__init(etsi_its_denm_ts_msgs__msg__IvimReference * msg)
{
  if (!msg) {
    return false;
  }
  // service_provider_id
  if (!etsi_its_denm_ts_msgs__msg__Provider__init(&msg->service_provider_id)) {
    etsi_its_denm_ts_msgs__msg__IvimReference__fini(msg);
    return false;
  }
  // ivi_identification_number
  if (!etsi_its_denm_ts_msgs__msg__IviIdentificationNumber__init(&msg->ivi_identification_number)) {
    etsi_its_denm_ts_msgs__msg__IvimReference__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_denm_ts_msgs__msg__IvimReference__fini(etsi_its_denm_ts_msgs__msg__IvimReference * msg)
{
  if (!msg) {
    return;
  }
  // service_provider_id
  etsi_its_denm_ts_msgs__msg__Provider__fini(&msg->service_provider_id);
  // ivi_identification_number
  etsi_its_denm_ts_msgs__msg__IviIdentificationNumber__fini(&msg->ivi_identification_number);
}

bool
etsi_its_denm_ts_msgs__msg__IvimReference__are_equal(const etsi_its_denm_ts_msgs__msg__IvimReference * lhs, const etsi_its_denm_ts_msgs__msg__IvimReference * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // service_provider_id
  if (!etsi_its_denm_ts_msgs__msg__Provider__are_equal(
      &(lhs->service_provider_id), &(rhs->service_provider_id)))
  {
    return false;
  }
  // ivi_identification_number
  if (!etsi_its_denm_ts_msgs__msg__IviIdentificationNumber__are_equal(
      &(lhs->ivi_identification_number), &(rhs->ivi_identification_number)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_denm_ts_msgs__msg__IvimReference__copy(
  const etsi_its_denm_ts_msgs__msg__IvimReference * input,
  etsi_its_denm_ts_msgs__msg__IvimReference * output)
{
  if (!input || !output) {
    return false;
  }
  // service_provider_id
  if (!etsi_its_denm_ts_msgs__msg__Provider__copy(
      &(input->service_provider_id), &(output->service_provider_id)))
  {
    return false;
  }
  // ivi_identification_number
  if (!etsi_its_denm_ts_msgs__msg__IviIdentificationNumber__copy(
      &(input->ivi_identification_number), &(output->ivi_identification_number)))
  {
    return false;
  }
  return true;
}

etsi_its_denm_ts_msgs__msg__IvimReference *
etsi_its_denm_ts_msgs__msg__IvimReference__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__IvimReference * msg = (etsi_its_denm_ts_msgs__msg__IvimReference *)allocator.allocate(sizeof(etsi_its_denm_ts_msgs__msg__IvimReference), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_denm_ts_msgs__msg__IvimReference));
  bool success = etsi_its_denm_ts_msgs__msg__IvimReference__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_denm_ts_msgs__msg__IvimReference__destroy(etsi_its_denm_ts_msgs__msg__IvimReference * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_denm_ts_msgs__msg__IvimReference__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_denm_ts_msgs__msg__IvimReference__Sequence__init(etsi_its_denm_ts_msgs__msg__IvimReference__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__IvimReference * data = NULL;

  if (size) {
    data = (etsi_its_denm_ts_msgs__msg__IvimReference *)allocator.zero_allocate(size, sizeof(etsi_its_denm_ts_msgs__msg__IvimReference), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_denm_ts_msgs__msg__IvimReference__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_denm_ts_msgs__msg__IvimReference__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_denm_ts_msgs__msg__IvimReference__Sequence__fini(etsi_its_denm_ts_msgs__msg__IvimReference__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_denm_ts_msgs__msg__IvimReference__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_denm_ts_msgs__msg__IvimReference__Sequence *
etsi_its_denm_ts_msgs__msg__IvimReference__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__IvimReference__Sequence * array = (etsi_its_denm_ts_msgs__msg__IvimReference__Sequence *)allocator.allocate(sizeof(etsi_its_denm_ts_msgs__msg__IvimReference__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_denm_ts_msgs__msg__IvimReference__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_denm_ts_msgs__msg__IvimReference__Sequence__destroy(etsi_its_denm_ts_msgs__msg__IvimReference__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_denm_ts_msgs__msg__IvimReference__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_denm_ts_msgs__msg__IvimReference__Sequence__are_equal(const etsi_its_denm_ts_msgs__msg__IvimReference__Sequence * lhs, const etsi_its_denm_ts_msgs__msg__IvimReference__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_denm_ts_msgs__msg__IvimReference__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_denm_ts_msgs__msg__IvimReference__Sequence__copy(
  const etsi_its_denm_ts_msgs__msg__IvimReference__Sequence * input,
  etsi_its_denm_ts_msgs__msg__IvimReference__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_denm_ts_msgs__msg__IvimReference);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_denm_ts_msgs__msg__IvimReference * data =
      (etsi_its_denm_ts_msgs__msg__IvimReference *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_denm_ts_msgs__msg__IvimReference__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_denm_ts_msgs__msg__IvimReference__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_denm_ts_msgs__msg__IvimReference__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
