// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/IvimReference.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__IVIM_REFERENCE__TRAITS_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__IVIM_REFERENCE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_denm_ts_msgs/msg/detail/ivim_reference__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'service_provider_id'
#include "etsi_its_denm_ts_msgs/msg/detail/provider__traits.hpp"
// Member 'ivi_identification_number'
#include "etsi_its_denm_ts_msgs/msg/detail/ivi_identification_number__traits.hpp"

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const IvimReference & msg,
  std::ostream & out)
{
  out << "{";
  // member: service_provider_id
  {
    out << "service_provider_id: ";
    to_flow_style_yaml(msg.service_provider_id, out);
    out << ", ";
  }

  // member: ivi_identification_number
  {
    out << "ivi_identification_number: ";
    to_flow_style_yaml(msg.ivi_identification_number, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const IvimReference & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: service_provider_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "service_provider_id:\n";
    to_block_style_yaml(msg.service_provider_id, out, indentation + 2);
  }

  // member: ivi_identification_number
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ivi_identification_number:\n";
    to_block_style_yaml(msg.ivi_identification_number, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const IvimReference & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_denm_ts_msgs::msg::IvimReference & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_denm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_denm_ts_msgs::msg::IvimReference & msg)
{
  return etsi_its_denm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_denm_ts_msgs::msg::IvimReference>()
{
  return "etsi_its_denm_ts_msgs::msg::IvimReference";
}

template<>
inline const char * name<etsi_its_denm_ts_msgs::msg::IvimReference>()
{
  return "etsi_its_denm_ts_msgs/msg/IvimReference";
}

template<>
struct has_fixed_size<etsi_its_denm_ts_msgs::msg::IvimReference>
  : std::integral_constant<bool, has_fixed_size<etsi_its_denm_ts_msgs::msg::IviIdentificationNumber>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::Provider>::value> {};

template<>
struct has_bounded_size<etsi_its_denm_ts_msgs::msg::IvimReference>
  : std::integral_constant<bool, has_bounded_size<etsi_its_denm_ts_msgs::msg::IviIdentificationNumber>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::Provider>::value> {};

template<>
struct is_message<etsi_its_denm_ts_msgs::msg::IvimReference>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__IVIM_REFERENCE__TRAITS_HPP_
