// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/MapemElementReference.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__MAPEM_ELEMENT_REFERENCE__TRAITS_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__MAPEM_ELEMENT_REFERENCE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_denm_ts_msgs/msg/detail/mapem_element_reference__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'map_reference'
#include "etsi_its_denm_ts_msgs/msg/detail/map_reference__traits.hpp"
// Member 'lane_ids'
#include "etsi_its_denm_ts_msgs/msg/detail/mapem_lane_list__traits.hpp"
// Member 'connection_ids'
#include "etsi_its_denm_ts_msgs/msg/detail/mapem_connection_list__traits.hpp"

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const MapemElementReference & msg,
  std::ostream & out)
{
  out << "{";
  // member: map_reference
  {
    out << "map_reference: ";
    to_flow_style_yaml(msg.map_reference, out);
    out << ", ";
  }

  // member: map_reference_is_present
  {
    out << "map_reference_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.map_reference_is_present, out);
    out << ", ";
  }

  // member: lane_ids
  {
    out << "lane_ids: ";
    to_flow_style_yaml(msg.lane_ids, out);
    out << ", ";
  }

  // member: lane_ids_is_present
  {
    out << "lane_ids_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.lane_ids_is_present, out);
    out << ", ";
  }

  // member: connection_ids
  {
    out << "connection_ids: ";
    to_flow_style_yaml(msg.connection_ids, out);
    out << ", ";
  }

  // member: connection_ids_is_present
  {
    out << "connection_ids_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.connection_ids_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MapemElementReference & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: map_reference
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "map_reference:\n";
    to_block_style_yaml(msg.map_reference, out, indentation + 2);
  }

  // member: map_reference_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "map_reference_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.map_reference_is_present, out);
    out << "\n";
  }

  // member: lane_ids
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lane_ids:\n";
    to_block_style_yaml(msg.lane_ids, out, indentation + 2);
  }

  // member: lane_ids_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lane_ids_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.lane_ids_is_present, out);
    out << "\n";
  }

  // member: connection_ids
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "connection_ids:\n";
    to_block_style_yaml(msg.connection_ids, out, indentation + 2);
  }

  // member: connection_ids_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "connection_ids_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.connection_ids_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MapemElementReference & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_denm_ts_msgs::msg::MapemElementReference & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_denm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_denm_ts_msgs::msg::MapemElementReference & msg)
{
  return etsi_its_denm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_denm_ts_msgs::msg::MapemElementReference>()
{
  return "etsi_its_denm_ts_msgs::msg::MapemElementReference";
}

template<>
inline const char * name<etsi_its_denm_ts_msgs::msg::MapemElementReference>()
{
  return "etsi_its_denm_ts_msgs/msg/MapemElementReference";
}

template<>
struct has_fixed_size<etsi_its_denm_ts_msgs::msg::MapemElementReference>
  : std::integral_constant<bool, has_fixed_size<etsi_its_denm_ts_msgs::msg::MapReference>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::MapemConnectionList>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::MapemLaneList>::value> {};

template<>
struct has_bounded_size<etsi_its_denm_ts_msgs::msg::MapemElementReference>
  : std::integral_constant<bool, has_bounded_size<etsi_its_denm_ts_msgs::msg::MapReference>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::MapemConnectionList>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::MapemLaneList>::value> {};

template<>
struct is_message<etsi_its_denm_ts_msgs::msg::MapemElementReference>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__MAPEM_ELEMENT_REFERENCE__TRAITS_HPP_
