// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/PathExtended.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PATH_EXTENDED__STRUCT_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PATH_EXTENDED__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'path'
#include "etsi_its_denm_ts_msgs/msg/detail/path__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__PathExtended __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__PathExtended __declspec(deprecated)
#endif

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PathExtended_
{
  using Type = PathExtended_<ContainerAllocator>;

  explicit PathExtended_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : path(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->point_of_event_zone = 0;
    }
  }

  explicit PathExtended_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : path(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->point_of_event_zone = 0;
    }
  }

  // field types and members
  using _point_of_event_zone_type =
    uint8_t;
  _point_of_event_zone_type point_of_event_zone;
  using _path_type =
    etsi_its_denm_ts_msgs::msg::Path_<ContainerAllocator>;
  _path_type path;

  // setters for named parameter idiom
  Type & set__point_of_event_zone(
    const uint8_t & _arg)
  {
    this->point_of_event_zone = _arg;
    return *this;
  }
  Type & set__path(
    const etsi_its_denm_ts_msgs::msg::Path_<ContainerAllocator> & _arg)
  {
    this->path = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t POINT_OF_EVENT_ZONE_MIN =
    1u;
  static constexpr uint8_t POINT_OF_EVENT_ZONE_MAX =
    23u;

  // pointer types
  using RawPtr =
    etsi_its_denm_ts_msgs::msg::PathExtended_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_ts_msgs::msg::PathExtended_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::PathExtended_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::PathExtended_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::PathExtended_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::PathExtended_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::PathExtended_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::PathExtended_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::PathExtended_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::PathExtended_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__PathExtended
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::PathExtended_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__PathExtended
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::PathExtended_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PathExtended_ & other) const
  {
    if (this->point_of_event_zone != other.point_of_event_zone) {
      return false;
    }
    if (this->path != other.path) {
      return false;
    }
    return true;
  }
  bool operator!=(const PathExtended_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PathExtended_

// alias to use template instance with default allocator
using PathExtended =
  etsi_its_denm_ts_msgs::msg::PathExtended_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PathExtended_<ContainerAllocator>::POINT_OF_EVENT_ZONE_MIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PathExtended_<ContainerAllocator>::POINT_OF_EVENT_ZONE_MAX;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PATH_EXTENDED__STRUCT_HPP_
