// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/PreCrashContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PRE_CRASH_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PRE_CRASH_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'perceived_pre_crash_object'
#include "etsi_its_denm_ts_msgs/msg/detail/perceived_object__struct.hpp"
// Member 'object_station_id'
#include "etsi_its_denm_ts_msgs/msg/detail/station_id__struct.hpp"
// Member 'time_to_collision'
#include "etsi_its_denm_ts_msgs/msg/detail/delta_time_milli_second_positive__struct.hpp"
// Member 'impact_section'
#include "etsi_its_denm_ts_msgs/msg/detail/object_face__struct.hpp"
// Member 'estimated_braking_distance'
#include "etsi_its_denm_ts_msgs/msg/detail/standard_length12b__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__PreCrashContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__PreCrashContainer __declspec(deprecated)
#endif

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PreCrashContainer_
{
  using Type = PreCrashContainer_<ContainerAllocator>;

  explicit PreCrashContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : perceived_pre_crash_object(_init),
    object_station_id(_init),
    time_to_collision(_init),
    impact_section(_init),
    estimated_braking_distance(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->object_station_id_is_present = false;
      this->time_to_collision_is_present = false;
      this->impact_section_is_present = false;
      this->estimated_braking_distance_is_present = false;
    }
  }

  explicit PreCrashContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : perceived_pre_crash_object(_alloc, _init),
    object_station_id(_alloc, _init),
    time_to_collision(_alloc, _init),
    impact_section(_alloc, _init),
    estimated_braking_distance(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->object_station_id_is_present = false;
      this->time_to_collision_is_present = false;
      this->impact_section_is_present = false;
      this->estimated_braking_distance_is_present = false;
    }
  }

  // field types and members
  using _perceived_pre_crash_object_type =
    etsi_its_denm_ts_msgs::msg::PerceivedObject_<ContainerAllocator>;
  _perceived_pre_crash_object_type perceived_pre_crash_object;
  using _object_station_id_type =
    etsi_its_denm_ts_msgs::msg::StationId_<ContainerAllocator>;
  _object_station_id_type object_station_id;
  using _object_station_id_is_present_type =
    bool;
  _object_station_id_is_present_type object_station_id_is_present;
  using _time_to_collision_type =
    etsi_its_denm_ts_msgs::msg::DeltaTimeMilliSecondPositive_<ContainerAllocator>;
  _time_to_collision_type time_to_collision;
  using _time_to_collision_is_present_type =
    bool;
  _time_to_collision_is_present_type time_to_collision_is_present;
  using _impact_section_type =
    etsi_its_denm_ts_msgs::msg::ObjectFace_<ContainerAllocator>;
  _impact_section_type impact_section;
  using _impact_section_is_present_type =
    bool;
  _impact_section_is_present_type impact_section_is_present;
  using _estimated_braking_distance_type =
    etsi_its_denm_ts_msgs::msg::StandardLength12b_<ContainerAllocator>;
  _estimated_braking_distance_type estimated_braking_distance;
  using _estimated_braking_distance_is_present_type =
    bool;
  _estimated_braking_distance_is_present_type estimated_braking_distance_is_present;

  // setters for named parameter idiom
  Type & set__perceived_pre_crash_object(
    const etsi_its_denm_ts_msgs::msg::PerceivedObject_<ContainerAllocator> & _arg)
  {
    this->perceived_pre_crash_object = _arg;
    return *this;
  }
  Type & set__object_station_id(
    const etsi_its_denm_ts_msgs::msg::StationId_<ContainerAllocator> & _arg)
  {
    this->object_station_id = _arg;
    return *this;
  }
  Type & set__object_station_id_is_present(
    const bool & _arg)
  {
    this->object_station_id_is_present = _arg;
    return *this;
  }
  Type & set__time_to_collision(
    const etsi_its_denm_ts_msgs::msg::DeltaTimeMilliSecondPositive_<ContainerAllocator> & _arg)
  {
    this->time_to_collision = _arg;
    return *this;
  }
  Type & set__time_to_collision_is_present(
    const bool & _arg)
  {
    this->time_to_collision_is_present = _arg;
    return *this;
  }
  Type & set__impact_section(
    const etsi_its_denm_ts_msgs::msg::ObjectFace_<ContainerAllocator> & _arg)
  {
    this->impact_section = _arg;
    return *this;
  }
  Type & set__impact_section_is_present(
    const bool & _arg)
  {
    this->impact_section_is_present = _arg;
    return *this;
  }
  Type & set__estimated_braking_distance(
    const etsi_its_denm_ts_msgs::msg::StandardLength12b_<ContainerAllocator> & _arg)
  {
    this->estimated_braking_distance = _arg;
    return *this;
  }
  Type & set__estimated_braking_distance_is_present(
    const bool & _arg)
  {
    this->estimated_braking_distance_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_denm_ts_msgs::msg::PreCrashContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_ts_msgs::msg::PreCrashContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::PreCrashContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::PreCrashContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::PreCrashContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::PreCrashContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::PreCrashContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::PreCrashContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::PreCrashContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::PreCrashContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__PreCrashContainer
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::PreCrashContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__PreCrashContainer
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::PreCrashContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PreCrashContainer_ & other) const
  {
    if (this->perceived_pre_crash_object != other.perceived_pre_crash_object) {
      return false;
    }
    if (this->object_station_id != other.object_station_id) {
      return false;
    }
    if (this->object_station_id_is_present != other.object_station_id_is_present) {
      return false;
    }
    if (this->time_to_collision != other.time_to_collision) {
      return false;
    }
    if (this->time_to_collision_is_present != other.time_to_collision_is_present) {
      return false;
    }
    if (this->impact_section != other.impact_section) {
      return false;
    }
    if (this->impact_section_is_present != other.impact_section_is_present) {
      return false;
    }
    if (this->estimated_braking_distance != other.estimated_braking_distance) {
      return false;
    }
    if (this->estimated_braking_distance_is_present != other.estimated_braking_distance_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const PreCrashContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PreCrashContainer_

// alias to use template instance with default allocator
using PreCrashContainer =
  etsi_its_denm_ts_msgs::msg::PreCrashContainer_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PRE_CRASH_CONTAINER__STRUCT_HPP_
