// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/SensorTypes.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__SENSOR_TYPES__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__SENSOR_TYPES__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'SIZE_BITS'.
enum
{
  etsi_its_denm_ts_msgs__msg__SensorTypes__SIZE_BITS = 16
};

/// Constant 'BIT_INDEX_UNDEFINED'.
enum
{
  etsi_its_denm_ts_msgs__msg__SensorTypes__BIT_INDEX_UNDEFINED = 0
};

/// Constant 'BIT_INDEX_RADAR'.
enum
{
  etsi_its_denm_ts_msgs__msg__SensorTypes__BIT_INDEX_RADAR = 1
};

/// Constant 'BIT_INDEX_LIDAR'.
enum
{
  etsi_its_denm_ts_msgs__msg__SensorTypes__BIT_INDEX_LIDAR = 2
};

/// Constant 'BIT_INDEX_MONOVIDEO'.
enum
{
  etsi_its_denm_ts_msgs__msg__SensorTypes__BIT_INDEX_MONOVIDEO = 3
};

/// Constant 'BIT_INDEX_STEREOVISION'.
enum
{
  etsi_its_denm_ts_msgs__msg__SensorTypes__BIT_INDEX_STEREOVISION = 4
};

/// Constant 'BIT_INDEX_NIGHTVISION'.
enum
{
  etsi_its_denm_ts_msgs__msg__SensorTypes__BIT_INDEX_NIGHTVISION = 5
};

/// Constant 'BIT_INDEX_ULTRASONIC'.
enum
{
  etsi_its_denm_ts_msgs__msg__SensorTypes__BIT_INDEX_ULTRASONIC = 6
};

/// Constant 'BIT_INDEX_PMD'.
enum
{
  etsi_its_denm_ts_msgs__msg__SensorTypes__BIT_INDEX_PMD = 7
};

/// Constant 'BIT_INDEX_INDUCTION_LOOP'.
enum
{
  etsi_its_denm_ts_msgs__msg__SensorTypes__BIT_INDEX_INDUCTION_LOOP = 8
};

/// Constant 'BIT_INDEX_SPHERICAL_CAMERA'.
enum
{
  etsi_its_denm_ts_msgs__msg__SensorTypes__BIT_INDEX_SPHERICAL_CAMERA = 9
};

/// Constant 'BIT_INDEX_UWB'.
enum
{
  etsi_its_denm_ts_msgs__msg__SensorTypes__BIT_INDEX_UWB = 10
};

/// Constant 'BIT_INDEX_ACOUSTIC'.
enum
{
  etsi_its_denm_ts_msgs__msg__SensorTypes__BIT_INDEX_ACOUSTIC = 11
};

/// Constant 'BIT_INDEX_LOCAL_AGGREGATION'.
enum
{
  etsi_its_denm_ts_msgs__msg__SensorTypes__BIT_INDEX_LOCAL_AGGREGATION = 12
};

/// Constant 'BIT_INDEX_ITS_AGGREGATION'.
enum
{
  etsi_its_denm_ts_msgs__msg__SensorTypes__BIT_INDEX_ITS_AGGREGATION = 13
};

// Include directives for member types
// Member 'value'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/SensorTypes in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__SensorTypes
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates the type of sensor(s).
  ///  * The corresponding bit shall be set to 1 under the following conditions:
  ///  *
  ///  * - 0  `undefined`         - in case the sensor type is undefined.
  ///  * - 1  `radar`             - in case the sensor is a radar,
  ///  * - 2  `lidar`             - in case the sensor is a lidar,
  ///  * - 3  `monovideo`         - in case the sensor is mono video,
  ///  * - 4  `stereovision`      - in case the sensor is stereo vision,
  ///  * - 5  `nightvision`       - in case the sensor is night vision,
  ///  * - 6  `ultrasonic`        - in case the sensor is ultrasonic,
  ///  * - 7  `pmd`               - in case the sensor is photonic mixing device,
  ///  * - 8  `inductionLoop`     - in case the sensor is an induction loop,
  ///  * - 9  `sphericalCamera`   - in case the sensor is a spherical camera,
  ///  * - 10 `uwb`               - in case the sensor is ultra wide band,
  ///  * - 11 `acoustic`          - in case the sensor is acoustic,
  ///  * - 12 `localAggregation`  - in case the information is provided by a system that aggregates information from different local sensors. Aggregation may include fusion,
  ///  * - 13 `itsAggregation`    - in case the information is provided by a system that aggregates information from other received ITS messages.
  ///  * - 14-15                  - are reserved for future usage.
  ///  *
  ///  * @note: If all bits are set to 0, then no sensor type is used
  ///  *
  ///  * @category: Sensing Information
  ///  * @revision: created in V2.2.1
  /// */
  /// SensorTypes ::= BIT STRING {
  ///     undefined         (0),
  ///     radar             (1),
  ///     lidar             (2),
  ///     monovideo         (3),
  ///     stereovision      (4),
  ///     nightvision       (5),
  ///     ultrasonic        (6),
  ///     pmd               (7),
  ///     inductionLoop     (8),
  ///     sphericalCamera   (9),
  ///     uwb               (10),
  ///     acoustic          (11),
  ///     localAggregation  (12),
  ///     itsAggregation    (13)
  /// } (SIZE (16,... ))
  /// ------------------------------------------------------------------------------
  rosidl_runtime_c__uint8__Sequence value;
  uint8_t bits_unused;
} etsi_its_denm_ts_msgs__msg__SensorTypes;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__SensorTypes.
typedef struct etsi_its_denm_ts_msgs__msg__SensorTypes__Sequence
{
  etsi_its_denm_ts_msgs__msg__SensorTypes * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__SensorTypes__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__SENSOR_TYPES__STRUCT_H_
