// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/UsageIndication.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__USAGE_INDICATION__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__USAGE_INDICATION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'NO_INDICATION'.
enum
{
  etsi_its_denm_ts_msgs__msg__UsageIndication__NO_INDICATION = 0
};

/// Constant 'SPECIAL_USE'.
enum
{
  etsi_its_denm_ts_msgs__msg__UsageIndication__SPECIAL_USE = 1
};

/// Constant 'RESCUE_OPERATION'.
enum
{
  etsi_its_denm_ts_msgs__msg__UsageIndication__RESCUE_OPERATION = 2
};

/// Struct defined in msg/UsageIndication in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__UsageIndication
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE represents indication of how a certain path or area will be used.
  ///  *
  ///  * The value shall be set to:
  ///  * - 0  - ` noIndication `     - in case it will remain free to be used,
  ///  * - 1  - ` specialUse `       - in case it will be physically blocked by special use,
  ///  * - 2  - ` rescueOperation`   - in case it is intended to be used for rescue operations,
  ///  *
  ///  * @category: Basic information
  ///  * @revision: Created in V2.2.1
  ///  */
  /// UsageIndication ::= ENUMERATED {
  ///     noIndication(0),
  ///     specialUse (1),
  ///     rescueOperation (2),
  ///     ...
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_denm_ts_msgs__msg__UsageIndication;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__UsageIndication.
typedef struct etsi_its_denm_ts_msgs__msg__UsageIndication__Sequence
{
  etsi_its_denm_ts_msgs__msg__UsageIndication * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__UsageIndication__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__USAGE_INDICATION__STRUCT_H_
