// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/LanePositionWithLateralDetails.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__LANE_POSITION_WITH_LATERAL_DETAILS__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__LANE_POSITION_WITH_LATERAL_DETAILS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'LANE_TYPE_DEFAULT'.
enum
{
  etsi_its_denm_ts_msgs__msg__LanePositionWithLateralDetails__LANE_TYPE_DEFAULT = 0
};

/// Constant 'DIRECTION_DEFAULT'.
enum
{
  etsi_its_denm_ts_msgs__msg__LanePositionWithLateralDetails__DIRECTION_DEFAULT = 0
};

// Include directives for member types
// Member 'transversal_position'
#include "etsi_its_denm_ts_msgs/msg/detail/lane_position__struct.h"
// Member 'lane_type'
#include "etsi_its_denm_ts_msgs/msg/detail/lane_type__struct.h"
// Member 'direction'
#include "etsi_its_denm_ts_msgs/msg/detail/direction__struct.h"
// Member 'distance_to_left_border'
// Member 'distance_to_right_border'
#include "etsi_its_denm_ts_msgs/msg/detail/standard_length9b__struct.h"

/// Struct defined in msg/LanePositionWithLateralDetails in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__LanePositionWithLateralDetails
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF is a third-level DF that represents a lane position and is an extended version of @ref LanePositionAndType that adds the distances to the left and right lane border.
  ///  *
  ///  * It shall additionally include the following components:
  ///  *
  ///  * @field distanceToLeftBorder: the distance of the transversal position to the left lane border. The real value shall be rounded to the next lower encoding-value.
  ///  *
  ///  * @field distanceToRightBorder: the distance of the transversal position to the right lane border. The real value shall be rounded to the next lower encoding-value.
  ///  *
  ///  * @category: Road Topology information
  ///  * @revision: Created in V2.2.1
  ///  */
  /// LanePositionWithLateralDetails ::= SEQUENCE {
  ///     COMPONENTS OF               LanePositionAndType,
  ///     distanceToLeftBorder        StandardLength9b,
  ///     distanceToRightBorder       StandardLength9b,
  ///     ...
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_denm_ts_msgs__msg__LanePosition transversal_position;
  etsi_its_denm_ts_msgs__msg__LaneType lane_type;
  etsi_its_denm_ts_msgs__msg__Direction direction;
  etsi_its_denm_ts_msgs__msg__StandardLength9b distance_to_left_border;
  etsi_its_denm_ts_msgs__msg__StandardLength9b distance_to_right_border;
} etsi_its_denm_ts_msgs__msg__LanePositionWithLateralDetails;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__LanePositionWithLateralDetails.
typedef struct etsi_its_denm_ts_msgs__msg__LanePositionWithLateralDetails__Sequence
{
  etsi_its_denm_ts_msgs__msg__LanePositionWithLateralDetails * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__LanePositionWithLateralDetails__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__LANE_POSITION_WITH_LATERAL_DETAILS__STRUCT_H_
