// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_denm_ts_msgs:msg/LocationContainer.idl
// generated code does not contain a copyright notice
#include "etsi_its_denm_ts_msgs/msg/detail/location_container__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `event_speed`
#include "etsi_its_denm_ts_msgs/msg/detail/speed__functions.h"
// Member `event_position_heading`
#include "etsi_its_denm_ts_msgs/msg/detail/wgs84_angle__functions.h"
// Member `detection_zones_to_event_position`
#include "etsi_its_denm_ts_msgs/msg/detail/traces__functions.h"
// Member `road_type`
#include "etsi_its_denm_ts_msgs/msg/detail/road_type__functions.h"
// Member `lane_positions`
#include "etsi_its_denm_ts_msgs/msg/detail/generalized_lane_positions__functions.h"
// Member `occupied_lanes`
#include "etsi_its_denm_ts_msgs/msg/detail/occupied_lanes_with_confidence__functions.h"
// Member `linked_ivims`
#include "etsi_its_denm_ts_msgs/msg/detail/ivim_references__functions.h"
// Member `linked_mapems`
#include "etsi_its_denm_ts_msgs/msg/detail/map_references__functions.h"
// Member `detection_zones_to_specified_event_point`
#include "etsi_its_denm_ts_msgs/msg/detail/traces_extended__functions.h"
// Member `predicted_paths`
#include "etsi_its_denm_ts_msgs/msg/detail/path_predicted_list__functions.h"

bool
etsi_its_denm_ts_msgs__msg__LocationContainer__init(etsi_its_denm_ts_msgs__msg__LocationContainer * msg)
{
  if (!msg) {
    return false;
  }
  // event_speed
  if (!etsi_its_denm_ts_msgs__msg__Speed__init(&msg->event_speed)) {
    etsi_its_denm_ts_msgs__msg__LocationContainer__fini(msg);
    return false;
  }
  // event_speed_is_present
  // event_position_heading
  if (!etsi_its_denm_ts_msgs__msg__Wgs84Angle__init(&msg->event_position_heading)) {
    etsi_its_denm_ts_msgs__msg__LocationContainer__fini(msg);
    return false;
  }
  // event_position_heading_is_present
  // detection_zones_to_event_position
  if (!etsi_its_denm_ts_msgs__msg__Traces__init(&msg->detection_zones_to_event_position)) {
    etsi_its_denm_ts_msgs__msg__LocationContainer__fini(msg);
    return false;
  }
  // road_type
  if (!etsi_its_denm_ts_msgs__msg__RoadType__init(&msg->road_type)) {
    etsi_its_denm_ts_msgs__msg__LocationContainer__fini(msg);
    return false;
  }
  // road_type_is_present
  // lane_positions
  if (!etsi_its_denm_ts_msgs__msg__GeneralizedLanePositions__init(&msg->lane_positions)) {
    etsi_its_denm_ts_msgs__msg__LocationContainer__fini(msg);
    return false;
  }
  // lane_positions_is_present
  // occupied_lanes
  if (!etsi_its_denm_ts_msgs__msg__OccupiedLanesWithConfidence__init(&msg->occupied_lanes)) {
    etsi_its_denm_ts_msgs__msg__LocationContainer__fini(msg);
    return false;
  }
  // occupied_lanes_is_present
  // linked_ivims
  if (!etsi_its_denm_ts_msgs__msg__IvimReferences__init(&msg->linked_ivims)) {
    etsi_its_denm_ts_msgs__msg__LocationContainer__fini(msg);
    return false;
  }
  // linked_ivims_is_present
  // linked_mapems
  if (!etsi_its_denm_ts_msgs__msg__MapReferences__init(&msg->linked_mapems)) {
    etsi_its_denm_ts_msgs__msg__LocationContainer__fini(msg);
    return false;
  }
  // linked_mapems_is_present
  // detection_zones_to_specified_event_point
  if (!etsi_its_denm_ts_msgs__msg__TracesExtended__init(&msg->detection_zones_to_specified_event_point)) {
    etsi_its_denm_ts_msgs__msg__LocationContainer__fini(msg);
    return false;
  }
  // detection_zones_to_specified_event_point_is_present
  // predicted_paths
  if (!etsi_its_denm_ts_msgs__msg__PathPredictedList__init(&msg->predicted_paths)) {
    etsi_its_denm_ts_msgs__msg__LocationContainer__fini(msg);
    return false;
  }
  // predicted_paths_is_present
  return true;
}

void
etsi_its_denm_ts_msgs__msg__LocationContainer__fini(etsi_its_denm_ts_msgs__msg__LocationContainer * msg)
{
  if (!msg) {
    return;
  }
  // event_speed
  etsi_its_denm_ts_msgs__msg__Speed__fini(&msg->event_speed);
  // event_speed_is_present
  // event_position_heading
  etsi_its_denm_ts_msgs__msg__Wgs84Angle__fini(&msg->event_position_heading);
  // event_position_heading_is_present
  // detection_zones_to_event_position
  etsi_its_denm_ts_msgs__msg__Traces__fini(&msg->detection_zones_to_event_position);
  // road_type
  etsi_its_denm_ts_msgs__msg__RoadType__fini(&msg->road_type);
  // road_type_is_present
  // lane_positions
  etsi_its_denm_ts_msgs__msg__GeneralizedLanePositions__fini(&msg->lane_positions);
  // lane_positions_is_present
  // occupied_lanes
  etsi_its_denm_ts_msgs__msg__OccupiedLanesWithConfidence__fini(&msg->occupied_lanes);
  // occupied_lanes_is_present
  // linked_ivims
  etsi_its_denm_ts_msgs__msg__IvimReferences__fini(&msg->linked_ivims);
  // linked_ivims_is_present
  // linked_mapems
  etsi_its_denm_ts_msgs__msg__MapReferences__fini(&msg->linked_mapems);
  // linked_mapems_is_present
  // detection_zones_to_specified_event_point
  etsi_its_denm_ts_msgs__msg__TracesExtended__fini(&msg->detection_zones_to_specified_event_point);
  // detection_zones_to_specified_event_point_is_present
  // predicted_paths
  etsi_its_denm_ts_msgs__msg__PathPredictedList__fini(&msg->predicted_paths);
  // predicted_paths_is_present
}

bool
etsi_its_denm_ts_msgs__msg__LocationContainer__are_equal(const etsi_its_denm_ts_msgs__msg__LocationContainer * lhs, const etsi_its_denm_ts_msgs__msg__LocationContainer * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // event_speed
  if (!etsi_its_denm_ts_msgs__msg__Speed__are_equal(
      &(lhs->event_speed), &(rhs->event_speed)))
  {
    return false;
  }
  // event_speed_is_present
  if (lhs->event_speed_is_present != rhs->event_speed_is_present) {
    return false;
  }
  // event_position_heading
  if (!etsi_its_denm_ts_msgs__msg__Wgs84Angle__are_equal(
      &(lhs->event_position_heading), &(rhs->event_position_heading)))
  {
    return false;
  }
  // event_position_heading_is_present
  if (lhs->event_position_heading_is_present != rhs->event_position_heading_is_present) {
    return false;
  }
  // detection_zones_to_event_position
  if (!etsi_its_denm_ts_msgs__msg__Traces__are_equal(
      &(lhs->detection_zones_to_event_position), &(rhs->detection_zones_to_event_position)))
  {
    return false;
  }
  // road_type
  if (!etsi_its_denm_ts_msgs__msg__RoadType__are_equal(
      &(lhs->road_type), &(rhs->road_type)))
  {
    return false;
  }
  // road_type_is_present
  if (lhs->road_type_is_present != rhs->road_type_is_present) {
    return false;
  }
  // lane_positions
  if (!etsi_its_denm_ts_msgs__msg__GeneralizedLanePositions__are_equal(
      &(lhs->lane_positions), &(rhs->lane_positions)))
  {
    return false;
  }
  // lane_positions_is_present
  if (lhs->lane_positions_is_present != rhs->lane_positions_is_present) {
    return false;
  }
  // occupied_lanes
  if (!etsi_its_denm_ts_msgs__msg__OccupiedLanesWithConfidence__are_equal(
      &(lhs->occupied_lanes), &(rhs->occupied_lanes)))
  {
    return false;
  }
  // occupied_lanes_is_present
  if (lhs->occupied_lanes_is_present != rhs->occupied_lanes_is_present) {
    return false;
  }
  // linked_ivims
  if (!etsi_its_denm_ts_msgs__msg__IvimReferences__are_equal(
      &(lhs->linked_ivims), &(rhs->linked_ivims)))
  {
    return false;
  }
  // linked_ivims_is_present
  if (lhs->linked_ivims_is_present != rhs->linked_ivims_is_present) {
    return false;
  }
  // linked_mapems
  if (!etsi_its_denm_ts_msgs__msg__MapReferences__are_equal(
      &(lhs->linked_mapems), &(rhs->linked_mapems)))
  {
    return false;
  }
  // linked_mapems_is_present
  if (lhs->linked_mapems_is_present != rhs->linked_mapems_is_present) {
    return false;
  }
  // detection_zones_to_specified_event_point
  if (!etsi_its_denm_ts_msgs__msg__TracesExtended__are_equal(
      &(lhs->detection_zones_to_specified_event_point), &(rhs->detection_zones_to_specified_event_point)))
  {
    return false;
  }
  // detection_zones_to_specified_event_point_is_present
  if (lhs->detection_zones_to_specified_event_point_is_present != rhs->detection_zones_to_specified_event_point_is_present) {
    return false;
  }
  // predicted_paths
  if (!etsi_its_denm_ts_msgs__msg__PathPredictedList__are_equal(
      &(lhs->predicted_paths), &(rhs->predicted_paths)))
  {
    return false;
  }
  // predicted_paths_is_present
  if (lhs->predicted_paths_is_present != rhs->predicted_paths_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_denm_ts_msgs__msg__LocationContainer__copy(
  const etsi_its_denm_ts_msgs__msg__LocationContainer * input,
  etsi_its_denm_ts_msgs__msg__LocationContainer * output)
{
  if (!input || !output) {
    return false;
  }
  // event_speed
  if (!etsi_its_denm_ts_msgs__msg__Speed__copy(
      &(input->event_speed), &(output->event_speed)))
  {
    return false;
  }
  // event_speed_is_present
  output->event_speed_is_present = input->event_speed_is_present;
  // event_position_heading
  if (!etsi_its_denm_ts_msgs__msg__Wgs84Angle__copy(
      &(input->event_position_heading), &(output->event_position_heading)))
  {
    return false;
  }
  // event_position_heading_is_present
  output->event_position_heading_is_present = input->event_position_heading_is_present;
  // detection_zones_to_event_position
  if (!etsi_its_denm_ts_msgs__msg__Traces__copy(
      &(input->detection_zones_to_event_position), &(output->detection_zones_to_event_position)))
  {
    return false;
  }
  // road_type
  if (!etsi_its_denm_ts_msgs__msg__RoadType__copy(
      &(input->road_type), &(output->road_type)))
  {
    return false;
  }
  // road_type_is_present
  output->road_type_is_present = input->road_type_is_present;
  // lane_positions
  if (!etsi_its_denm_ts_msgs__msg__GeneralizedLanePositions__copy(
      &(input->lane_positions), &(output->lane_positions)))
  {
    return false;
  }
  // lane_positions_is_present
  output->lane_positions_is_present = input->lane_positions_is_present;
  // occupied_lanes
  if (!etsi_its_denm_ts_msgs__msg__OccupiedLanesWithConfidence__copy(
      &(input->occupied_lanes), &(output->occupied_lanes)))
  {
    return false;
  }
  // occupied_lanes_is_present
  output->occupied_lanes_is_present = input->occupied_lanes_is_present;
  // linked_ivims
  if (!etsi_its_denm_ts_msgs__msg__IvimReferences__copy(
      &(input->linked_ivims), &(output->linked_ivims)))
  {
    return false;
  }
  // linked_ivims_is_present
  output->linked_ivims_is_present = input->linked_ivims_is_present;
  // linked_mapems
  if (!etsi_its_denm_ts_msgs__msg__MapReferences__copy(
      &(input->linked_mapems), &(output->linked_mapems)))
  {
    return false;
  }
  // linked_mapems_is_present
  output->linked_mapems_is_present = input->linked_mapems_is_present;
  // detection_zones_to_specified_event_point
  if (!etsi_its_denm_ts_msgs__msg__TracesExtended__copy(
      &(input->detection_zones_to_specified_event_point), &(output->detection_zones_to_specified_event_point)))
  {
    return false;
  }
  // detection_zones_to_specified_event_point_is_present
  output->detection_zones_to_specified_event_point_is_present = input->detection_zones_to_specified_event_point_is_present;
  // predicted_paths
  if (!etsi_its_denm_ts_msgs__msg__PathPredictedList__copy(
      &(input->predicted_paths), &(output->predicted_paths)))
  {
    return false;
  }
  // predicted_paths_is_present
  output->predicted_paths_is_present = input->predicted_paths_is_present;
  return true;
}

etsi_its_denm_ts_msgs__msg__LocationContainer *
etsi_its_denm_ts_msgs__msg__LocationContainer__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__LocationContainer * msg = (etsi_its_denm_ts_msgs__msg__LocationContainer *)allocator.allocate(sizeof(etsi_its_denm_ts_msgs__msg__LocationContainer), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_denm_ts_msgs__msg__LocationContainer));
  bool success = etsi_its_denm_ts_msgs__msg__LocationContainer__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_denm_ts_msgs__msg__LocationContainer__destroy(etsi_its_denm_ts_msgs__msg__LocationContainer * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_denm_ts_msgs__msg__LocationContainer__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_denm_ts_msgs__msg__LocationContainer__Sequence__init(etsi_its_denm_ts_msgs__msg__LocationContainer__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__LocationContainer * data = NULL;

  if (size) {
    data = (etsi_its_denm_ts_msgs__msg__LocationContainer *)allocator.zero_allocate(size, sizeof(etsi_its_denm_ts_msgs__msg__LocationContainer), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_denm_ts_msgs__msg__LocationContainer__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_denm_ts_msgs__msg__LocationContainer__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_denm_ts_msgs__msg__LocationContainer__Sequence__fini(etsi_its_denm_ts_msgs__msg__LocationContainer__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_denm_ts_msgs__msg__LocationContainer__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_denm_ts_msgs__msg__LocationContainer__Sequence *
etsi_its_denm_ts_msgs__msg__LocationContainer__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__LocationContainer__Sequence * array = (etsi_its_denm_ts_msgs__msg__LocationContainer__Sequence *)allocator.allocate(sizeof(etsi_its_denm_ts_msgs__msg__LocationContainer__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_denm_ts_msgs__msg__LocationContainer__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_denm_ts_msgs__msg__LocationContainer__Sequence__destroy(etsi_its_denm_ts_msgs__msg__LocationContainer__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_denm_ts_msgs__msg__LocationContainer__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_denm_ts_msgs__msg__LocationContainer__Sequence__are_equal(const etsi_its_denm_ts_msgs__msg__LocationContainer__Sequence * lhs, const etsi_its_denm_ts_msgs__msg__LocationContainer__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_denm_ts_msgs__msg__LocationContainer__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_denm_ts_msgs__msg__LocationContainer__Sequence__copy(
  const etsi_its_denm_ts_msgs__msg__LocationContainer__Sequence * input,
  etsi_its_denm_ts_msgs__msg__LocationContainer__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_denm_ts_msgs__msg__LocationContainer);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_denm_ts_msgs__msg__LocationContainer * data =
      (etsi_its_denm_ts_msgs__msg__LocationContainer *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_denm_ts_msgs__msg__LocationContainer__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_denm_ts_msgs__msg__LocationContainer__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_denm_ts_msgs__msg__LocationContainer__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
