// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/MapemElementReference.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__MAPEM_ELEMENT_REFERENCE__STRUCT_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__MAPEM_ELEMENT_REFERENCE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'map_reference'
#include "etsi_its_denm_ts_msgs/msg/detail/map_reference__struct.hpp"
// Member 'lane_ids'
#include "etsi_its_denm_ts_msgs/msg/detail/mapem_lane_list__struct.hpp"
// Member 'connection_ids'
#include "etsi_its_denm_ts_msgs/msg/detail/mapem_connection_list__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__MapemElementReference __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__MapemElementReference __declspec(deprecated)
#endif

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MapemElementReference_
{
  using Type = MapemElementReference_<ContainerAllocator>;

  explicit MapemElementReference_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : map_reference(_init),
    lane_ids(_init),
    connection_ids(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->map_reference_is_present = false;
      this->lane_ids_is_present = false;
      this->connection_ids_is_present = false;
    }
  }

  explicit MapemElementReference_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : map_reference(_alloc, _init),
    lane_ids(_alloc, _init),
    connection_ids(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->map_reference_is_present = false;
      this->lane_ids_is_present = false;
      this->connection_ids_is_present = false;
    }
  }

  // field types and members
  using _map_reference_type =
    etsi_its_denm_ts_msgs::msg::MapReference_<ContainerAllocator>;
  _map_reference_type map_reference;
  using _map_reference_is_present_type =
    bool;
  _map_reference_is_present_type map_reference_is_present;
  using _lane_ids_type =
    etsi_its_denm_ts_msgs::msg::MapemLaneList_<ContainerAllocator>;
  _lane_ids_type lane_ids;
  using _lane_ids_is_present_type =
    bool;
  _lane_ids_is_present_type lane_ids_is_present;
  using _connection_ids_type =
    etsi_its_denm_ts_msgs::msg::MapemConnectionList_<ContainerAllocator>;
  _connection_ids_type connection_ids;
  using _connection_ids_is_present_type =
    bool;
  _connection_ids_is_present_type connection_ids_is_present;

  // setters for named parameter idiom
  Type & set__map_reference(
    const etsi_its_denm_ts_msgs::msg::MapReference_<ContainerAllocator> & _arg)
  {
    this->map_reference = _arg;
    return *this;
  }
  Type & set__map_reference_is_present(
    const bool & _arg)
  {
    this->map_reference_is_present = _arg;
    return *this;
  }
  Type & set__lane_ids(
    const etsi_its_denm_ts_msgs::msg::MapemLaneList_<ContainerAllocator> & _arg)
  {
    this->lane_ids = _arg;
    return *this;
  }
  Type & set__lane_ids_is_present(
    const bool & _arg)
  {
    this->lane_ids_is_present = _arg;
    return *this;
  }
  Type & set__connection_ids(
    const etsi_its_denm_ts_msgs::msg::MapemConnectionList_<ContainerAllocator> & _arg)
  {
    this->connection_ids = _arg;
    return *this;
  }
  Type & set__connection_ids_is_present(
    const bool & _arg)
  {
    this->connection_ids_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_denm_ts_msgs::msg::MapemElementReference_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_ts_msgs::msg::MapemElementReference_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::MapemElementReference_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::MapemElementReference_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::MapemElementReference_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::MapemElementReference_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::MapemElementReference_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::MapemElementReference_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::MapemElementReference_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::MapemElementReference_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__MapemElementReference
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::MapemElementReference_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__MapemElementReference
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::MapemElementReference_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MapemElementReference_ & other) const
  {
    if (this->map_reference != other.map_reference) {
      return false;
    }
    if (this->map_reference_is_present != other.map_reference_is_present) {
      return false;
    }
    if (this->lane_ids != other.lane_ids) {
      return false;
    }
    if (this->lane_ids_is_present != other.lane_ids_is_present) {
      return false;
    }
    if (this->connection_ids != other.connection_ids) {
      return false;
    }
    if (this->connection_ids_is_present != other.connection_ids_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const MapemElementReference_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MapemElementReference_

// alias to use template instance with default allocator
using MapemElementReference =
  etsi_its_denm_ts_msgs::msg::MapemElementReference_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__MAPEM_ELEMENT_REFERENCE__STRUCT_HPP_
