// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/RoadConfigurationSection.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_CONFIGURATION_SECTION__STRUCT_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_CONFIGURATION_SECTION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'road_section_definition'
#include "etsi_its_denm_ts_msgs/msg/detail/road_section_definition__struct.hpp"
// Member 'road_type'
#include "etsi_its_denm_ts_msgs/msg/detail/road_type__struct.hpp"
// Member 'lane_configuration'
#include "etsi_its_denm_ts_msgs/msg/detail/basic_lane_configuration__struct.hpp"
// Member 'mapem_configuration'
#include "etsi_its_denm_ts_msgs/msg/detail/mapem_configuration__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__RoadConfigurationSection __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__RoadConfigurationSection __declspec(deprecated)
#endif

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RoadConfigurationSection_
{
  using Type = RoadConfigurationSection_<ContainerAllocator>;

  explicit RoadConfigurationSection_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : road_section_definition(_init),
    road_type(_init),
    lane_configuration(_init),
    mapem_configuration(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->road_type_is_present = false;
      this->lane_configuration_is_present = false;
      this->mapem_configuration_is_present = false;
    }
  }

  explicit RoadConfigurationSection_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : road_section_definition(_alloc, _init),
    road_type(_alloc, _init),
    lane_configuration(_alloc, _init),
    mapem_configuration(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->road_type_is_present = false;
      this->lane_configuration_is_present = false;
      this->mapem_configuration_is_present = false;
    }
  }

  // field types and members
  using _road_section_definition_type =
    etsi_its_denm_ts_msgs::msg::RoadSectionDefinition_<ContainerAllocator>;
  _road_section_definition_type road_section_definition;
  using _road_type_type =
    etsi_its_denm_ts_msgs::msg::RoadType_<ContainerAllocator>;
  _road_type_type road_type;
  using _road_type_is_present_type =
    bool;
  _road_type_is_present_type road_type_is_present;
  using _lane_configuration_type =
    etsi_its_denm_ts_msgs::msg::BasicLaneConfiguration_<ContainerAllocator>;
  _lane_configuration_type lane_configuration;
  using _lane_configuration_is_present_type =
    bool;
  _lane_configuration_is_present_type lane_configuration_is_present;
  using _mapem_configuration_type =
    etsi_its_denm_ts_msgs::msg::MapemConfiguration_<ContainerAllocator>;
  _mapem_configuration_type mapem_configuration;
  using _mapem_configuration_is_present_type =
    bool;
  _mapem_configuration_is_present_type mapem_configuration_is_present;

  // setters for named parameter idiom
  Type & set__road_section_definition(
    const etsi_its_denm_ts_msgs::msg::RoadSectionDefinition_<ContainerAllocator> & _arg)
  {
    this->road_section_definition = _arg;
    return *this;
  }
  Type & set__road_type(
    const etsi_its_denm_ts_msgs::msg::RoadType_<ContainerAllocator> & _arg)
  {
    this->road_type = _arg;
    return *this;
  }
  Type & set__road_type_is_present(
    const bool & _arg)
  {
    this->road_type_is_present = _arg;
    return *this;
  }
  Type & set__lane_configuration(
    const etsi_its_denm_ts_msgs::msg::BasicLaneConfiguration_<ContainerAllocator> & _arg)
  {
    this->lane_configuration = _arg;
    return *this;
  }
  Type & set__lane_configuration_is_present(
    const bool & _arg)
  {
    this->lane_configuration_is_present = _arg;
    return *this;
  }
  Type & set__mapem_configuration(
    const etsi_its_denm_ts_msgs::msg::MapemConfiguration_<ContainerAllocator> & _arg)
  {
    this->mapem_configuration = _arg;
    return *this;
  }
  Type & set__mapem_configuration_is_present(
    const bool & _arg)
  {
    this->mapem_configuration_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_denm_ts_msgs::msg::RoadConfigurationSection_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_ts_msgs::msg::RoadConfigurationSection_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::RoadConfigurationSection_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::RoadConfigurationSection_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::RoadConfigurationSection_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::RoadConfigurationSection_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::RoadConfigurationSection_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::RoadConfigurationSection_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::RoadConfigurationSection_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::RoadConfigurationSection_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__RoadConfigurationSection
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::RoadConfigurationSection_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__RoadConfigurationSection
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::RoadConfigurationSection_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RoadConfigurationSection_ & other) const
  {
    if (this->road_section_definition != other.road_section_definition) {
      return false;
    }
    if (this->road_type != other.road_type) {
      return false;
    }
    if (this->road_type_is_present != other.road_type_is_present) {
      return false;
    }
    if (this->lane_configuration != other.lane_configuration) {
      return false;
    }
    if (this->lane_configuration_is_present != other.lane_configuration_is_present) {
      return false;
    }
    if (this->mapem_configuration != other.mapem_configuration) {
      return false;
    }
    if (this->mapem_configuration_is_present != other.mapem_configuration_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const RoadConfigurationSection_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RoadConfigurationSection_

// alias to use template instance with default allocator
using RoadConfigurationSection =
  etsi_its_denm_ts_msgs::msg::RoadConfigurationSection_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_CONFIGURATION_SECTION__STRUCT_HPP_
