// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/RoadConfigurationSection.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_CONFIGURATION_SECTION__TRAITS_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_CONFIGURATION_SECTION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_denm_ts_msgs/msg/detail/road_configuration_section__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'road_section_definition'
#include "etsi_its_denm_ts_msgs/msg/detail/road_section_definition__traits.hpp"
// Member 'road_type'
#include "etsi_its_denm_ts_msgs/msg/detail/road_type__traits.hpp"
// Member 'lane_configuration'
#include "etsi_its_denm_ts_msgs/msg/detail/basic_lane_configuration__traits.hpp"
// Member 'mapem_configuration'
#include "etsi_its_denm_ts_msgs/msg/detail/mapem_configuration__traits.hpp"

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const RoadConfigurationSection & msg,
  std::ostream & out)
{
  out << "{";
  // member: road_section_definition
  {
    out << "road_section_definition: ";
    to_flow_style_yaml(msg.road_section_definition, out);
    out << ", ";
  }

  // member: road_type
  {
    out << "road_type: ";
    to_flow_style_yaml(msg.road_type, out);
    out << ", ";
  }

  // member: road_type_is_present
  {
    out << "road_type_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.road_type_is_present, out);
    out << ", ";
  }

  // member: lane_configuration
  {
    out << "lane_configuration: ";
    to_flow_style_yaml(msg.lane_configuration, out);
    out << ", ";
  }

  // member: lane_configuration_is_present
  {
    out << "lane_configuration_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.lane_configuration_is_present, out);
    out << ", ";
  }

  // member: mapem_configuration
  {
    out << "mapem_configuration: ";
    to_flow_style_yaml(msg.mapem_configuration, out);
    out << ", ";
  }

  // member: mapem_configuration_is_present
  {
    out << "mapem_configuration_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.mapem_configuration_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RoadConfigurationSection & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: road_section_definition
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "road_section_definition:\n";
    to_block_style_yaml(msg.road_section_definition, out, indentation + 2);
  }

  // member: road_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "road_type:\n";
    to_block_style_yaml(msg.road_type, out, indentation + 2);
  }

  // member: road_type_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "road_type_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.road_type_is_present, out);
    out << "\n";
  }

  // member: lane_configuration
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lane_configuration:\n";
    to_block_style_yaml(msg.lane_configuration, out, indentation + 2);
  }

  // member: lane_configuration_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lane_configuration_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.lane_configuration_is_present, out);
    out << "\n";
  }

  // member: mapem_configuration
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "mapem_configuration:\n";
    to_block_style_yaml(msg.mapem_configuration, out, indentation + 2);
  }

  // member: mapem_configuration_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "mapem_configuration_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.mapem_configuration_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RoadConfigurationSection & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_denm_ts_msgs::msg::RoadConfigurationSection & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_denm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_denm_ts_msgs::msg::RoadConfigurationSection & msg)
{
  return etsi_its_denm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_denm_ts_msgs::msg::RoadConfigurationSection>()
{
  return "etsi_its_denm_ts_msgs::msg::RoadConfigurationSection";
}

template<>
inline const char * name<etsi_its_denm_ts_msgs::msg::RoadConfigurationSection>()
{
  return "etsi_its_denm_ts_msgs/msg/RoadConfigurationSection";
}

template<>
struct has_fixed_size<etsi_its_denm_ts_msgs::msg::RoadConfigurationSection>
  : std::integral_constant<bool, has_fixed_size<etsi_its_denm_ts_msgs::msg::BasicLaneConfiguration>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::MapemConfiguration>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::RoadSectionDefinition>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::RoadType>::value> {};

template<>
struct has_bounded_size<etsi_its_denm_ts_msgs::msg::RoadConfigurationSection>
  : std::integral_constant<bool, has_bounded_size<etsi_its_denm_ts_msgs::msg::BasicLaneConfiguration>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::MapemConfiguration>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::RoadSectionDefinition>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::RoadType>::value> {};

template<>
struct is_message<etsi_its_denm_ts_msgs::msg::RoadConfigurationSection>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_CONFIGURATION_SECTION__TRAITS_HPP_
